import logging

import xhtml2pdf.pisa as pisa
from django.template.loader import get_template

logger = logging.getLogger(__name__)


# def get_report_header(cls):
#     header = ReportHeader.objects.get(pk=1)
#     file_path = os.path.join(settings.MEDIA_ROOT, unicode(header.header_file))
#     if not os.path.exists(file_path):
#         raise Exception("Header image not found")
#     return file_path
#
#
# def get_user_signature(cls, user_id):
#     try:
#         user_profile = UserProfile.objects.get(user_id=user_id)
#         signature = os.path.join(settings.MEDIA_ROOT, unicode(user_profile.signature_file))
#     except UserProfile.DoesNotExist:
#         signature = None
#     return signature


def generate_html(study, report, template_location='report/general.html', print_header=True):
    template = get_template(template_location)
    context = {'study': study,
               'report': report,
               'print_header': print_header,
               'signature': 'HbSEM.png'}
    logger.info(f'Generate html for study {study.guid} and report {report.id}')
    # FIXME: Fix timezone of times generated by HTML
    html = template.render(context=context)
    logger.info('HTML file is generated')
    return html


# TODO: https://codeburst.io/django-render-html-to-pdf-41a2b9c41d16
def generate_pdf(source_html, output_filepath):
    logger.info(f'Generate PDF file from html to {output_filepath}')

    # FIXME: Need better handling of this case
    # TODO: Should we pass fileObject only
    logger.info('Creating pdf ...')
    if type(output_filepath) in [str, bytes]:
        with open(output_filepath, "w+b") as tmp_pdf:
            pisa_status = pisa.CreatePDF(source_html, dest=tmp_pdf)
    else:
        pisa_status = pisa.CreatePDF(source_html, dest=output_filepath)

    logger.info(f'pisa status {pisa_status}, error status: {pisa_status.err}')
    if pisa_status:
        logger.info(f'pdf file is generated at {output_filepath}')
    else:
        logger.error('Can not generate pdf file from html')
        logger.debug('html file', source_html)
        raise Exception('Can not create pdf from html')
